/*
***************************************************************************
*
* Author: Teunis van Beelen
*
* Copyright (C) 2007, 2008, 2009 Teunis van Beelen
*
* teuniz@gmail.com
*
***************************************************************************
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation version 2 of the License.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
***************************************************************************
*
* This version of GPL is at http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
*
***************************************************************************
*/




#ifndef COLORMENUFORM1_H
#define COLORMENUFORM1_H



#include <QApplication>
#include <QObject>
#include <QWidget>
#include <QDialog>
#include <QPushButton>

#include "global.h"
#include "special_button.h"




class UI_Mainwindow;



class UI_ColorMenuDialog : public QObject
{
  Q_OBJECT

public:

  UI_ColorMenuDialog(QWidget *viewcurvewidget=0, int *signalcolor=0, SpecialButton *coloredbutton=0);

private:

int *color;

QWidget      *curvewidget;

QDialog      *colormenu_dialog;

QPushButton  *CloseButton;

SpecialButton *ColorButton1,
              *ColorButton2,
              *ColorButton3,
              *ColorButton4,
              *ColorButton5,
              *ColorButton6,
              *ColorButton7,
              *ColorButton8,
              *ColorButton9,
              *ColorButton10,
              *ColorButton11,
              *ColorButton12,
              *ColorButton13,
              *ColorButton14,
              *ColorButton15,
              *ColorButton16,
              *parentbutton;


private slots:

void ColorButton1_pressed();
void ColorButton2_pressed();
void ColorButton3_pressed();
void ColorButton4_pressed();
void ColorButton5_pressed();
void ColorButton6_pressed();
void ColorButton7_pressed();
void ColorButton8_pressed();
void ColorButton9_pressed();
void ColorButton10_pressed();
void ColorButton11_pressed();
void ColorButton12_pressed();
void ColorButton13_pressed();
void ColorButton14_pressed();
void ColorButton15_pressed();
void ColorButton16_pressed();

};



#endif // COLORMENUFORM1_H


