/*
***************************************************************************
*
* Author: Teunis van Beelen
*
* Copyright (C) 2007, 2008, 2009 Teunis van Beelen
*
* teuniz@gmail.com
*
***************************************************************************
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation version 2 of the License.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along
* with this program; if not, write to the Free Software Foundation, Inc.,
* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
*
***************************************************************************
*
* This version of GPL is at http://www.gnu.org/licenses/old-licenses/gpl-2.0.txt
*
***************************************************************************
*/



#include "show_actual_montage_dialog.h"



UI_ShowActualMontagewindow::UI_ShowActualMontagewindow(QWidget *parent)
{
  int i, j, k, len;

  char txtbuf[2048];

  mainwindow = (UI_Mainwindow *)parent;

  ShowMontageDialog = new QDialog;

  ShowMontageDialog->setMinimumSize(QSize(400, 300));
  ShowMontageDialog->resize(600, 440);
  ShowMontageDialog->setWindowTitle("Show montage");
  ShowMontageDialog->setModal(TRUE);
  ShowMontageDialog->setAttribute(Qt::WA_DeleteOnClose, TRUE);

  textedit1 = new QTextEdit;
  textedit1->setFrameStyle(QFrame::Panel | QFrame::Sunken);
  textedit1->setReadOnly(TRUE);
  textedit1->setLineWrapMode(QTextEdit::NoWrap);
  textedit1->setFont(*mainwindow->monofont);

  CloseButton = new QPushButton;
  CloseButton->setFixedSize(100, 25);
  CloseButton->setText("Close");

  box = new QBoxLayout(QBoxLayout::TopToBottom, ShowMontageDialog);
  box->addWidget(textedit1);
  box->addWidget(CloseButton, 0, Qt::AlignRight);

  QObject::connect(CloseButton,  SIGNAL(clicked()), ShowMontageDialog, SLOT(close()));

  for(i=0; i<mainwindow->signalcomps; i++)
  {
    sprintf(txtbuf, "%3i: ", i + 1);

    for(j=0; j<mainwindow->signalcomp[i]->num_of_signals; j++)
    {
      sprintf(txtbuf + strlen(txtbuf), "%+ix %s",
              mainwindow->signalcomp[i]->factor[j],
              mainwindow->signalcomp[i]->edfhdr->edfparam[mainwindow->signalcomp[i]->edfsignal[j]].label);

      len = strlen(txtbuf);
      for(k=(len-1); k>0; k--)
      {
        if(txtbuf[k]!=' ')  break;
      }
      txtbuf[k+3] = 0;

      strcat(txtbuf, "\t");
    }

    for(j=0; j<mainwindow->signalcomp[i]->filter_cnt; j++)
    {
      if(mainwindow->signalcomp[i]->filter[j]->is_LPF)
      {
        sprintf(txtbuf + strlen(txtbuf), "LPF: %f", mainwindow->signalcomp[i]->filter[j]->cutoff_frequency);
      }
      else
      {
        sprintf(txtbuf + strlen(txtbuf), "HPF: %f", mainwindow->signalcomp[i]->filter[j]->cutoff_frequency);
      }

      len = strlen(txtbuf);
      for(k=(len-1); k>0; k--)
      {
        if(txtbuf[k]!='0')  break;
      }

      if(txtbuf[k]=='.')  txtbuf[k] = 0;
      else  txtbuf[k+1] = 0;

      sprintf(txtbuf + strlen(txtbuf), "Hz\t");
    }

    sprintf(txtbuf + strlen(txtbuf), "%f", mainwindow->signalcomp[i]->voltpercm);

    len = strlen(txtbuf);
    for(k=(len-1); k>0; k--)
    {
      if(txtbuf[k]!='0')  break;
    }

    if(txtbuf[k]=='.')  txtbuf[k] = 0;
    else  txtbuf[k+1] = 0;

    strcat(txtbuf, mainwindow->signalcomp[i]->edfhdr->edfparam[mainwindow->signalcomp[i]->edfsignal[0]].physdimension);

    len = strlen(txtbuf);
    for(k=(len-1); k>0; k--)
    {
      if(txtbuf[k]!=' ')  break;
    }
    txtbuf[k+1] = 0;

    strcat(txtbuf, "/cm");

    sprintf(txtbuf + strlen(txtbuf), "\toffset: %f", (double)mainwindow->signalcomp[i]->screen_offset * mainwindow->pixelsizefactor * mainwindow->signalcomp[i]->voltpercm);

    len = strlen(txtbuf);
    for(k=(len-1); k>0; k--)
    {
      if(txtbuf[k]!='0')  break;
    }

    if(txtbuf[k]=='.')  txtbuf[k] = 0;
    else  txtbuf[k+1] = 0;

    strcat(txtbuf, mainwindow->signalcomp[i]->edfhdr->edfparam[mainwindow->signalcomp[i]->edfsignal[0]].physdimension);

    textedit1->append(txtbuf);
  }

  ShowMontageDialog->exec();
}







